local UIUtil = import('/lua/modules/ui/uiutil.lua')
local GameMain = import('/lua/modules/ui/game/gamemain.lua')
local img='/mods/unitcam/textures'
local myunitview = false
local miniMapControls = import('/lua/modules/ui/game/multifunction.lua').controls


function Init(minimap)
	ConExecute("cam_nearzoom 2")
	CreateButton(minimap.BG)
	CreateWindow(minimap)
end

	
function CreateButton(minimap)
	local parent = GameMain.GetGameParent()
	button = UIUtil.CreateCheckbox(parent, img.. '/unitcam-up.dds', img.. '/unitcam-up_sel.dds', img.. '/unitcam-over.dds', img.. '/unitcam-over_sel.dds', img.. '/unitcam-dis.dds', img.. '/unitcam-dis_sel.dds')
	button.Left:Set(function() return minimap.Left() + 2 end)
	button.Top:Set(function() return minimap.Top() + 2 end)
	button.Depth:Set( 600 )
	button.OnCheck = function(self, checked)
		if checked then
			miniMapControls.miniMap:Hide()
			miniMapControls.miniMap.BG:Show()
			CamWindow:Show()
			SetCam()
		else
			CamWindow:Hide()
			miniMapControls.miniMap:Show()
		end
	end
end


function CreateWindow(minimap)
    if myunitview == false then
		CamWindow = import('/lua/modules/ui/controls/worldview.lua').WorldView(GameMain.GetGameParent(), 'UnitCam', 2, false, 'WorldCamera')    -- depth value is above minimap
        CamWindow:SetName("CamWindow")
        CamWindow:SetRenderPass(UIUtil.UIRP_UnderWorld) -- don't change this or the camera will lag one frame behind
        CamWindow.Depth:Set(10)
        CamWindow:SetNeedsFrameUpdate(true)
		CamWindow.Left:Set(minimap.Left)
		CamWindow.Top:Set(minimap.Top)
		CamWindow.Right:Set(minimap.Right)
		CamWindow.Bottom:Set(minimap.Bottom) 
		CamWindow:Hide()
	end
end


function SetCam()
	local cam = GetCamera("UnitCam")
	local selection = GetSelectedUnits()
	if selection then
		local unitid = selection[1]:GetEntityId()
		cam:NoseCam(unitid, 0.3 , 0.1, 0)
	end
end
